## alicevision 3.3.0+repack

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(aliceVision LANGUAGES C CXX)

option(ALICEVISION_BUILD_DEPENDENCIES "Build all AliceVision dependencies" OFF)
option(AV_BUILD_ALICEVISION "Enable building of AliceVision" ON)
option(AV_EIGEN_MEMORY_ALIGNMENT "Enable Eigen memory alignment" ON)
option(ALICEVISION_BUILD_TESTS "Build AliceVision tests" OFF)
option(AV_USE_CUDA "Enable CUDA" ON)
option(AV_USE_OPENMP "Enable OpenMP" $<$<CXX_COMPILER_ID:"AppleClang">,OFF,ON>) # disable by default for AppleClang
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(ALICEVISION_INSTALL_MESHROOM_PLUGIN "Install AliceVision's plugin for Meshroom" ON)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type for AliceVision" FORCE)
endif()

# set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type for AliceVision")
set(DEPS_CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type for all external libraries (only used if ALICEVISION_BUILD_DEPENDENCIES=ON)")
string(TOLOWER ${DEPS_CMAKE_BUILD_TYPE} DEPS_CMAKE_BUILD_TYPE_LOWERCASE)
set(ALICEVISION_BUNDLE_PREFIX "${CMAKE_INSTALL_PREFIX}/bundle" CACHE STRING "Path for bundle installation")
set(ALICEVISION_ROOT ${PROJECT_BINARY_DIR})

# ==============================================================================
# GNUInstallDirs CMake module
# - Define GNU standard installation directories
# - Provides install directory variables as defined by the GNU Coding Standards.
# ==============================================================================
include(GNUInstallDirs)

if (CMAKE_BUILD_TYPE MATCHES Release)
    message(STATUS "Force CMAKE_INSTALL_DO_STRIP in Release")
    set(CMAKE_INSTALL_DO_STRIP TRUE)
endif()

message(STATUS "----------------------------------------")
message(STATUS "ALICEVISION_BUILD_DEPENDENCIES: ${ALICEVISION_BUILD_DEPENDENCIES}")
message(STATUS "ALICEVISION_BUILD_TESTS: ${ALICEVISION_BUILD_TESTS}")
message(STATUS "")
message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
message(STATUS "DEPS_CMAKE_BUILD_TYPE: ${DEPS_CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_INSTALL_LIBDIR: ${CMAKE_INSTALL_LIBDIR}")
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "CMAKE_INSTALL_RPATH: ${CMAKE_INSTALL_RPATH}")
message(STATUS "CMAKE_INSTALL_DO_STRIP: ${CMAKE_INSTALL_DO_STRIP}")
message(STATUS "----------------------------------------")

# Eigen requires overaligned buffers for maximum efficiency (e.g. on AVX512 buffers may need to
# be aligned to 64 bytes). Fortunately this is fixed in C++17.
# See https://eigen.tuxfamily.org/dox/group__TopicUnalignedArrayAssert.html
# Only change this option to disable it for older compilers or for debug purposes.
if (NOT AV_EIGEN_MEMORY_ALIGNMENT)
    set(EIGEN_CMAKE_ALIGNMENT_FLAGS
        "-DCMAKE_CXX_FLAGS:STRING=-DEIGEN_MAX_ALIGN_BYTES=0 -DEIGEN_MAX_STATIC_ALIGN_BYTES=0"
        "-DCMAKE_C_FLAGS:STRING=-DEIGEN_MAX_ALIGN_BYTES=0 -DEIGEN_MAX_STATIC_ALIGN_BYTES=0")
endif()


# ==============================================================================
# Enable cmake UNIT TEST framework
# ==============================================================================
if (ALICEVISION_BUILD_TESTS)
    include(CTest)
    enable_testing()
endif()


if (ALICEVISION_BUILD_DEPENDENCIES)
    include(src/cmake/Dependencies.cmake)
else()
    # ==============================================================================
    # Standard cmake project without internal support for dependencies
    # ==============================================================================

    # Add sources
    add_subdirectory(src)

    install(
        FILES 
            LICENSE-MPL2.md 
            LICENSE-MIT-libmv.md 
            COPYING.md 
            CONTRIBUTORS.md
        DESTINATION ${CMAKE_INSTALL_DATADIR}/aliceVision
    )

endif()

if (ALICEVISION_INSTALL_MESHROOM_PLUGIN)
    install(
        DIRECTORY meshroom
        DESTINATION ${CMAKE_INSTALL_DATADIR}
    )
endif()

# Bundle target (see src/cmake/MakeBundle.cmake)
# Note: require that the install rule has been executed
# Include VCPKG installed dir for runtime dependencies lookup
set(BUNDLE_LIBS_PATHS "")
if (_VCPKG_INSTALLED_DIR)
    set(BUNDLE_LIBS_PATHS ${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}$<$<CONFIG:Debug>:/debug>/bin)
endif()

add_custom_target(bundle
    ${CMAKE_COMMAND}
    -DBUNDLE_INSTALL_PREFIX=${ALICEVISION_BUNDLE_PREFIX}
    -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
    -DBUNDLE_LIBS_PATHS=${BUNDLE_LIBS_PATHS}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/src/cmake/MakeBundle.cmake
)

set_target_properties(bundle PROPERTIES FOLDER Packaging)

=== src/aliceVision/CMakeLists.txt ===
# Common modules

add_subdirectory(image)
add_subdirectory(numeric)
add_subdirectory(system)
add_subdirectory(cmdline)
add_subdirectory(stl)
add_subdirectory(utils)
add_subdirectory(gpu)

# SfM modules

if (ALICEVISION_BUILD_SFM)
    add_subdirectory(camera)
    add_subdirectory(colorHarmonization)
    add_subdirectory(dataio)
    add_subdirectory(feature)
    add_subdirectory(featureEngine)
    add_subdirectory(geometry)
    add_subdirectory(graph)
    add_subdirectory(imageMatching)
    add_subdirectory(linearProgramming)
    add_subdirectory(lensCorrectionProfile)
    add_subdirectory(localization)
    add_subdirectory(matching)
    add_subdirectory(matchingImageCollection)
    add_subdirectory(multiview)
    add_subdirectory(rig)
    add_subdirectory(robustEstimation)
    add_subdirectory(sensorDB)
    add_subdirectory(sfm)
    add_subdirectory(sfmData)
    add_subdirectory(sfmDataIO)
    add_subdirectory(track)
    add_subdirectory(voctree)
    add_subdirectory(calibration)
    if (ALICEVISION_HAVE_OPENCV)
        add_subdirectory(imageMasking)
        add_subdirectory(keyframe)
    endif()
endif()

if (ALICEVISION_BUILD_PANORAMA)
    add_subdirectory(panorama)
endif()

if (ALICEVISION_BUILD_HDR)
    add_subdirectory(hdr)
endif()

# MVS modules

if (ALICEVISION_BUILD_MVS)
    add_subdirectory(mesh)
    add_subdirectory(mvsData)
    add_subdirectory(mvsUtils)
    add_subdirectory(fuseCut)

    if (ALICEVISION_HAVE_CUDA)
        add_subdirectory(depthMap)
    endif()
endif()

if (ALICEVISION_HAVE_ONNX)
    add_subdirectory(segmentation)
endif()

if (ALICEVISION_BUILD_SFM AND ALICEVISION_BUILD_MVS)
    add_subdirectory(sfmMvsUtils)
endif()

if (ALICEVISION_BUILD_PHOTOMETRICSTEREO)
    if (ALICEVISION_HAVE_OPENCV)
        add_subdirectory(photometricStereo)
        if (ALICEVISION_HAVE_ONNX)
            add_subdirectory(sphereDetection)
        endif()
        add_subdirectory(lightingEstimation)
    endif()
endif()

# Install rules

install(
    DIRECTORY .
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/aliceVision
    COMPONENT headers
    FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h" PATTERN "*.tcc"
)

# Add files to an empty target to get them in IDE
set(global_files_headers
    alicevision_omp.hpp
    prettyprint.hpp
    types.hpp
    version.hpp
)

add_custom_target(aliceVision_global_headers_ide SOURCES ${global_files_headers})

set_property(TARGET aliceVision_global_headers_ide
    PROPERTY FOLDER AliceVision
)

=== src/dependencies/CMakeLists.txt ===
## AliceVision dependencies

# Add nanoflann (header-only)
# add_library(nanoflann INTERFACE IMPORTED GLOBAL)
# set(NANOFLANN_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/nanoflann/include")
# set_target_properties(nanoflann PROPERTIES
#     INTERFACE_INCLUDE_DIRECTORIES "${NANOFLANN_INCLUDE_DIR}")

# libs should be static
set(BUILD_SHARED_LIBS OFF)

# use PIC code for link into shared lib
if(UNIX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
endif(UNIX)


# Add svg library
add_subdirectory(vectorGraphics)



list(APPEND directories histogram htmlDoc vectorGraphics)
foreach(inDirectory ${directories})
  install(
    DIRECTORY ./${inDirectory}
    DESTINATION include/aliceVision/dependencies/
    COMPONENT headers
    FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h"
  )
endforeach()

=== src/nonFree/CMakeLists.txt ===
add_subdirectory(sift)

=== src/software/CMakeLists.txt ===
## AliceVision
## Software

add_subdirectory(pipeline)
add_subdirectory(convert)
add_subdirectory(export)
add_subdirectory(utils)

=== src/aliceVision/calibration/CMakeLists.txt ===
# Headers
set(calibration_files_headers
    calibration.hpp
    bestImages.hpp
    patternDetect.hpp
    exportData.hpp
    distortionEstimation.hpp
    distortionEstimationLine.hpp
    distortionEstimationPoint.hpp
    distortionEstimationGeometry.hpp
    checkerDetector.hpp
    checkerDetector_io.hpp
)

# Sources
set(calibration_files_sources
    distortionEstimationLine.cpp
    distortionEstimationPoint.cpp
    distortionEstimationGeometry.cpp
    checkerDetector.cpp
    checkerDetector_io.cpp
)

if (ALICEVISION_HAVE_OPENCV)
    list(APPEND calibration_files_sources 
                bestImages.cpp
                calibration.cpp
                patternDetect.cpp
                exportData.cpp
    )
endif()

alicevision_add_library(aliceVision_calibration
    SOURCES ${calibration_files_headers} ${calibration_files_sources}
    PRIVATE_LINKS
        aliceVision_image
        aliceVision_system
        aliceVision_dataio
        Boost::program_options
        Boost::boost
        Boost::json
        ${CERES_LIBRARIES}
)

if (ALICEVISION_HAVE_OPENCV)
    target_link_libraries(aliceVision_calibration PUBLIC ${OpenCV_LIBS})
endif()

if (ALICEVISION_HAVE_CCTAG)
    target_link_libraries(aliceVision_calibration PRIVATE CCTag::CCTag)
endif()

=== src/aliceVision/camera/CMakeLists.txt ===
# Headers
set(camera_files_headers
	camera.hpp
	cameraCommon.hpp
	cameraUndistortImage.hpp
	Distortion.hpp
	DistortionBrown.hpp
	DistortionFisheye.hpp
	DistortionFisheye1.hpp
	DistortionRadial.hpp
	Undistortion.hpp
	Undistortion3DEA4.hpp
    Undistortion3DERadial4.hpp
    Undistortion3DEClassicLD.hpp
    UndistortionRadial.hpp
	Equidistant.hpp
    Equirectangular.hpp
	IntrinsicBase.hpp
	IntrinsicInitMode.hpp
	IntrinsicScaleOffset.hpp
	IntrinsicScaleOffsetDisto.hpp
	Pinhole.hpp
)

set(camera_files_sources
    DistortionBrown.cpp
    DistortionFisheye.cpp
    DistortionFisheye1.cpp
    DistortionRadial.cpp
    UndistortionRadial.cpp
    Equidistant.cpp
    Equirectangular.cpp
    IntrinsicBase.cpp
    IntrinsicScaleOffset.cpp
    IntrinsicScaleOffsetDisto.cpp
    Pinhole.cpp
	Undistortion.cpp
    Undistortion3DEA4.cpp
    Undistortion3DERadial4.cpp
    Undistortion3DEClassicLD.cpp
)

alicevision_add_library(aliceVision_camera
    SOURCES ${camera_files_headers} ${camera_files_sources}
    PUBLIC_LINKS
        aliceVision_numeric
        aliceVision_geometry
        aliceVision_image
        aliceVision_stl
        aliceVision_system
)

# Unit tests
alicevision_add_test(distortion_test.cpp        NAME "camera_distortionRadial"    LINKS aliceVision_camera)
alicevision_add_test(pinholeBrown_test.cpp      NAME "camera_pinholeBrown"        LINKS aliceVision_camera)
alicevision_add_test(pinholeFisheye_test.cpp    NAME "camera_pinholeFisheye"      LINKS aliceVision_camera)
alicevision_add_test(pinholeFisheye1_test.cpp   NAME "camera_pinholeFisheye1"     LINKS aliceVision_camera)
alicevision_add_test(pinholeRadial_test.cpp     NAME "camera_pinholeRadial"       LINKS aliceVision_camera)
alicevision_add_test(equidistant_test.cpp       NAME "camera_equidistant"         LINKS aliceVision_camera)


# SWIG Binding
if (ALICEVISION_BUILD_SWIG_BINDING)
    alicevision_swig_add_library(camera
        SOURCES Camera.i
        PUBLIC_LINKS
            aliceVision_camera
            ${Python3_LIBRARIES}
        PRIVATE_INCLUDE_DIRS
            ../include
            ${ALICEVISION_ROOT}/include
            ${Python3_INCLUDE_DIRS}
            ${Python3_NumPy_INCLUDE_DIRS}
    )
endif()

=== src/aliceVision/cmdline/CMakeLists.txt ===
# Sources
set(cmdline_files_sources
    cmdline.cpp
)

alicevision_add_library(aliceVision_cmdline
    SOURCES ${cmdline_files_sources}
    PUBLIC_LINKS
        Boost::program_options
    PRIVATE_LINKS
        aliceVision_system
)

=== src/aliceVision/colorHarmonization/CMakeLists.txt ===
# Headers
set(colorHarmonization_files_headers
    CommonDataByPair.hpp
    CommonDataByPair_fullFrame.hpp
    CommonDataByPair_matchedPoints.hpp
    CommonDataByPair_vldSegment.hpp
    GainOffsetConstraintBuilder.hpp
)

# Sources
set(colorHarmonization_files_sources
    GainOffsetConstraintBuilder.cpp
)

alicevision_add_library(aliceVision_colorHarmonization
    SOURCES ${colorHarmonization_files_headers} ${colorHarmonization_files_sources}
    PUBLIC_LINKS
        aliceVision_feature
        aliceVision_image
        aliceVision_linearProgramming
        aliceVision_matching
)

# Unit tests
alicevision_add_test(gainOffsetConstraintBuilder_test.cpp
    NAME "colorHarmonization_gainOffsetConstraintBuilder"
    LINKS aliceVision_colorHarmonization
)

=== src/aliceVision/dataio/CMakeLists.txt ===
# Headers
set(dataio_files_headers
    FeedProvider.hpp
    IFeed.hpp
    ImageFeed.hpp
    SfMDataFeed.hpp
    json.hpp
)

# Sources
set(dataio_files_sources
    FeedProvider.cpp
    IFeed.cpp
    ImageFeed.cpp
    SfMDataFeed.cpp
    json.cpp
)

if (ALICEVISION_HAVE_OPENCV)
    list(APPEND dataio_files_headers VideoFeed.hpp)
    list(APPEND dataio_files_sources VideoFeed.cpp)
endif()

if (NOT ALICEVISION_BUILD_LIDAR STREQUAL "OFF")
    list(APPEND dataio_files_headers E57Reader.hpp)
    list(APPEND dataio_files_sources E57Reader.cpp)
endif()

alicevision_add_library(aliceVision_dataio
    SOURCES ${dataio_files_headers} ${dataio_files_sources}
    PUBLIC_LINKS
        aliceVision_camera
        aliceVision_image
    PRIVATE_LINKS
        aliceVision_sfmData
        aliceVision_sfmDataIO
        aliceVision_system
        Boost::boost
        Boost::json
)

if (ALICEVISION_HAVE_OPENCV)
    target_link_libraries(aliceVision_dataio PRIVATE ${OpenCV_LIBS})
endif()

if (NOT ALICEVISION_BUILD_LIDAR STREQUAL "OFF")
    target_link_libraries(aliceVision_dataio PRIVATE E57Format)
endif()

=== src/aliceVision/depthMap/CMakeLists.txt ===
# Headers
set(depthMap_files_headers
    BufPtr.hpp
    computeOnMultiGPUs.hpp
    CustomPatchPatternParams.hpp
    DepthMapEstimator.hpp
    DepthMapParams.hpp
    depthMapUtils.hpp
    NormalMapEstimator.hpp
    Refine.hpp
    RefineParams.hpp
    Sgm.hpp
    SgmDepthList.hpp
    SgmParams.hpp
    Tile.hpp
    volumeIO.hpp
)

# Sources
set(depthMap_files_sources
    computeOnMultiGPUs.cpp
    CustomPatchPatternParams.cpp
    DepthMapEstimator.cpp
    depthMapUtils.cpp
    NormalMapEstimator.cpp
    Refine.cpp
    Sgm.cpp
    SgmDepthList.cpp
    volumeIO.cpp
)

# Cuda Host Headers Only
set(depthMap_cuda_host_headers
    cuda/host/LRUCameraCache.hpp
    cuda/host/LRUCache.hpp
    cuda/host/divUp.hpp
    cuda/host/memory.hpp
)

# Cuda Host Sources
set(depthMap_cuda_host_sources
    cuda/host/DeviceCache.hpp
    cuda/host/DeviceCache.cpp
    cuda/host/DeviceMipmapImage.hpp
    cuda/host/DeviceMipmapImage.cpp
    cuda/host/DeviceStreamManager.hpp
    cuda/host/DeviceStreamManager.cpp
    cuda/host/patchPattern.hpp
    cuda/host/patchPattern.cpp
    cuda/host/utils.hpp
    cuda/host/utils.cpp
)

# device CUDA Headers Only
set(depthMap_cuda_device_headers
    cuda/device/buffer.cuh
    cuda/device/color.cuh
    cuda/device/eig33.cuh
    cuda/device/matrix.cuh
    cuda/device/operators.cuh
    cuda/device/Patch.cuh
    cuda/device/SimStat.cuh
)

# device CUDA Sources
set(depthMap_cuda_device_sources
    cuda/device/DeviceCameraParams.hpp
    cuda/device/DeviceCameraParams.cu
    cuda/device/DevicePatchPattern.hpp
    cuda/device/DevicePatchPattern.cu
)

# imageProcessing CUDA Sources
set(depthMap_cuda_imageProcessing_sources
    cuda/imageProcessing/deviceGaussianFilter.hpp
    cuda/imageProcessing/deviceGaussianFilter.cu
    cuda/imageProcessing/deviceColorConversion.hpp
    cuda/imageProcessing/deviceColorConversion.cu
    cuda/imageProcessing/deviceMipmappedArray.hpp
    cuda/imageProcessing/deviceMipmappedArray.cu
)

# planeSweeping CUDA Headers Only
set(depthMap_cuda_planeSweeping_headers
    cuda/planeSweeping/deviceDepthSimilarityMapKernels.cuh
    cuda/planeSweeping/deviceSimilarityVolumeKernels.cuh
)

# planeSweeping CUDA Sources
set(depthMap_cuda_planeSweeping_sources
    cuda/planeSweeping/similarity.hpp
    cuda/planeSweeping/deviceDepthSimilarityMap.hpp
    cuda/planeSweeping/deviceDepthSimilarityMap.cu
    cuda/planeSweeping/deviceSimilarityVolume.hpp
    cuda/planeSweeping/deviceSimilarityVolume.cu
)

set_source_files_properties(
    ${depthMap_cuda_host_headers}
	${depthMap_cuda_device_headers} 
	${depthMap_cuda_planeSweeping_headers}
    PROPERTIES HEADER_FILE_ONLY true
)

source_group("aliceVision_depthMap_cuda_host" FILES ${depthMap_cuda_host_headers} ${depthMap_cuda_host_sources})
source_group("aliceVision_depthMap_cuda_device" FILES ${depthMap_cuda_device_headers} ${depthMap_cuda_device_sources})
source_group("aliceVision_depthMap_cuda_imageProcessing" FILES ${depthMap_cuda_imageProcessing_sources})
source_group("aliceVision_depthMap_cuda_planeSweeping" FILES ${depthMap_cuda_planeSweeping_headers} ${depthMap_cuda_planeSweeping_sources})

# Cuda Sources
set(depthMap_cuda_files_sources
    ${depthMap_cuda_host_headers} 
    ${depthMap_cuda_host_sources}
    ${depthMap_cuda_device_headers} 
    ${depthMap_cuda_device_sources}
    ${depthMap_cuda_imageProcessing_sources}
    ${depthMap_cuda_planeSweeping_headers} 
    ${depthMap_cuda_planeSweeping_sources}
)

alicevision_add_library(aliceVision_depthMap
    USE_CUDA
    SOURCES
        ${depthMap_files_headers}
        ${depthMap_files_sources}
        ${depthMap_cuda_files_sources}
    PUBLIC_LINKS
        aliceVision_mvsData
        aliceVision_mvsUtils
        aliceVision_system
        assimp::assimp
    PRIVATE_LINKS
        aliceVision_gpu
        aliceVision_sfmData
        aliceVision_sfmDataIO
    PUBLIC_INCLUDE_DIRS
        ${CUDA_INCLUDE_DIRS}
)

# target_compile_definitions(aliceVision_depthMap PUBLIC TSIM_USE_FLOAT)

=== src/aliceVision/feature/CMakeLists.txt ===
project(features)

# Headers
set(features_files_headers
    akaze/AKAZE.hpp
    akaze/descriptorLIOP.hpp
    akaze/descriptorMLDB.hpp
    akaze/descriptorMSURF.hpp
    akaze/ImageDescriber_AKAZE.hpp
    sift/ImageDescriber_SIFT.hpp
    sift/ImageDescriber_SIFT_vlfeat.hpp
    sift/ImageDescriber_SIFT_vlfeatFloat.hpp
    sift/ImageDescriber_DSPSIFT_vlfeat.hpp
    sift/SIFT.hpp
    Descriptor.hpp
    feature.hpp
    FeaturesPerView.hpp
    Hamming.hpp
    ImageDescriber.hpp
    imageDescriberCommon.hpp
    imageStats.hpp
    KeypointSet.hpp
    metric.hpp
    PointFeature.hpp
    Regions.hpp
    regionsFactory.hpp
    RegionsPerView.hpp
)

# Sources
set(features_files_sources
    akaze/AKAZE.cpp
    akaze/descriptorLIOP.cpp
    akaze/ImageDescriber_AKAZE.cpp
    sift/SIFT.cpp
    sift/ImageDescriber_DSPSIFT_vlfeat.cpp
    FeaturesPerView.cpp
    ImageDescriber.cpp
    imageDescriberCommon.cpp
    imageStats.cpp
)

# CCTAG ImageDescriber
if (ALICEVISION_HAVE_CCTAG)
    list(APPEND features_files_headers cctag/ImageDescriber_CCTAG.hpp)
    list(APPEND features_files_sources cctag/ImageDescriber_CCTAG.cpp)
endif()

# APRILTAG ImageDescriber
if (ALICEVISION_HAVE_APRILTAG)
    list(APPEND features_files_headers apriltag/ImageDescriber_APRILTAG.hpp)
    list(APPEND features_files_sources apriltag/ImageDescriber_APRILTAG.cpp)
endif()

# PopSIFT ImageDescriber
if (ALICEVISION_HAVE_POPSIFT)
    list(APPEND features_files_headers sift/ImageDescriber_SIFT_popSIFT.hpp)
    list(APPEND features_files_sources sift/ImageDescriber_SIFT_popSIFT.cpp)
endif()

# OpenCV ImageDescriber
if (ALICEVISION_HAVE_OPENCV)
    list(APPEND features_files_headers openCV/ImageDescriber_AKAZE_OCV.hpp)
    list(APPEND features_files_sources openCV/ImageDescriber_AKAZE_OCV.cpp)

    if (ALICEVISION_HAVE_OCVSIFT)
        list(APPEND features_files_headers openCV/ImageDescriber_SIFT_OCV.hpp)
        list(APPEND features_files_sources openCV/ImageDescriber_SIFT_OCV.cpp)
    endif()
endif()


alicevision_add_library(aliceVision_feature
    SOURCES ${features_files_headers} ${features_files_sources}
    PUBLIC_LINKS
        aliceVision_image
        aliceVision_numeric
        aliceVision_system
        aliceVision_gpu
        vlsift
    PRIVATE_LINKS
        Boost::boost
)

# Link CCTAG library
if (ALICEVISION_HAVE_CCTAG)
    target_link_libraries(aliceVision_feature PUBLIC CCTag::CCTag)
endif()

# Link APRILTAG library
if (ALICEVISION_HAVE_APRILTAG)
    target_link_libraries(aliceVision_feature PUBLIC apriltag::apriltag)
endif()

# Link PopSIFT library
if (ALICEVISION_HAVE_POPSIFT)
    target_link_libraries(aliceVision_feature PRIVATE PopSift::popsift)
endif()

# Link OpenCV library
if (ALICEVISION_HAVE_OPENCV)
    target_link_libraries(aliceVision_feature PUBLIC ${OpenCV_LIBS})
endif()

# Unit tests
alicevision_add_test(features_test.cpp NAME "features" LINKS aliceVision_feature)
alicevision_add_test(metric_test.cpp   NAME "descriptor_metric"   LINKS aliceVision_feature)

# SWIG Binding
if (ALICEVISION_BUILD_SWIG_BINDING)
    alicevision_swig_add_library(feature
        SOURCES feature.i
        PUBLIC_LINKS
            aliceVision_feature
            ${Python3_LIBRARIES}
        PRIVATE_INCLUDE_DIRS
            ../include
            ${ALICEVISION_ROOT}/include
            ${Python3_INCLUDE_DIRS}
            ${Python3_NumPy_INCLUDE_DIRS}
    )
endif()

=== debian/control ===
Source: alicevision
Section: contrib/libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libgeogram-dev,
               libalembic-graphics-dev,
               libapriltag-dev,
               libflann-dev,
               libnanoflann-dev,
               liblemon-dev,
               libcoin-dev,
               libceres-dev,
               libassimp-dev,
               libboost-all-dev,
               libopenimageio-dev,
               openimageio-tools,
               libmetis-dev,
               libopengv-dev,
               libopencv-dev,
               libmeshsdfilter-dev,
               libopenmesh-dev,
               libexpat1-dev,
               python3-imath,
               libtbb-dev,
               coinor-libcoinutils-dev,
               coinor-libclp-dev,
               liblz4-dev,
# Depth map processing is a part of most meshlab workflows, and it requires
# cuda. At this time we have nvidi-cuda-dev=12.4.1, which apparently doesn't
# work with gcc > 13.2:
#   https://docs.nvidia.com/cuda/archive/12.4.1/cuda-installation-guide-linux/index.html
# Today gcc-13 provides 13.4, so I request gcc-12, and I point nvcc at that.
               nvidia-cuda-toolkit,
               gcc-12,
               g++-12
Standards-Version: 4.6.0
Homepage: https://github.com/alicevision/AliceVision
Vcs-Git: https://salsa.debian.org/science-team/alicevision.git
Vcs-Browser: https://salsa.debian.org/science-team/alicevision

Package: libalicevision3
Section: contrib/libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libalicevision-data (= ${source:Version})
Description: Photogrammetric Computer Vision Framework
 AliceVision aims to provide strong software basis with state-of-the-art
 computer vision algorithms that can be tested, analyzed and reused. The project
 is a result of collaboration between academia and industry to provide
 cutting-edge algorithms with the robustness and the quality required for
 production usage.
 .
 This package provides the shared library

Package: libalicevision-dev
Section: contrib/libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libalicevision3 (= ${binary:Version}),
               libalembic-graphics-dev,
               libceres-dev,
               libapriltag-dev,
               libopengv-dev,
               libopencv-dev,
               libboost-all-dev,
               libopenimageio-dev,
               coinor-libcoinutils-dev,
               coinor-libosi-dev,
               coinor-libclp-dev
Description: Photogrammetric Computer Vision Framework
 AliceVision aims to provide strong software basis with state-of-the-art
 computer vision algorithms that can be tested, analyzed and reused. The project
 is a result of collaboration between academia and industry to provide
 cutting-edge algorithms with the robustness and the quality required for
 production usage.
 .
 This package provides the development files library

Package: libalicevision-data
Section: contrib/libs
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Photogrammetric Computer Vision Framework
 AliceVision aims to provide strong software basis with state-of-the-art
 computer vision algorithms that can be tested, analyzed and reused. The project
 is a result of collaboration between academia and industry to provide
 cutting-edge algorithms with the robustness and the quality required for
 production usage.
 .
 This package provides the data files

Package: alicevision
Section: contrib/science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libalicevision3 (= ${binary:Version})
Description: Photogrammetric Computer Vision Framework
 AliceVision aims to provide strong software basis with state-of-the-art
 computer vision algorithms that can be tested, analyzed and reused. The project
 is a result of collaboration between academia and industry to provide
 cutting-edge algorithms with the robustness and the quality required for
 production usage.
 .
 This package provides the executable tools

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

# I'd like to turn this on, but I get build errors
USE_OCVSIFT := OFF

# ON produces errors. Leave it OFF for now
REQUIRE_CERES_WITH_SUITESPARSE := OFF

override_dh_auto_configure:
	dh_auto_configure -- \
		-DALICEVISION_BUILD_DEPENDENCIES=OFF \
		-DALICEVISION_BUILD_TESTS=OFF \
		-DALICEVISION_INSTALL_MESHROOM_PLUGIN=ON \
		-DAV_BUILD_ALICEVISION=ON \
		-DAV_EIGEN_MEMORY_ALIGNMENT=ON \
		-DAV_USE_CUDA=ON \
		-DAV_USE_OPENMP=ON \
		-DBUILD_SHARED_LIBS=ON \
		\
		-DALICEVISION_BUILD_COVERAGE=OFF \
		-DALICEVISION_BUILD_DOC=OFF \
		-DALICEVISION_BUILD_HDR=ON \
		-DALICEVISION_BUILD_LIDAR=OFF \
		-DALICEVISION_BUILD_MVS=ON \
		-DALICEVISION_BUILD_PANORAMA=ON \
		-DALICEVISION_BUILD_PHOTOMETRICSTEREO=ON \
		-DALICEVISION_BUILD_SEGMENTATION=ON \
		-DALICEVISION_BUILD_SFM=ON \
		-DALICEVISION_BUILD_SOFTWARE=ON \
		-DALICEVISION_BUILD_SWIG_BINDING=OFF \
		-DALICEVISION_NVCC_WARNINGS=ON \
		-DALICEVISION_REMOVE_ABSOLUTE=ON \
		-DALICEVISION_REQUIRE_CERES_WITH_SUITESPARSE=$(REQUIRE_CERES_WITH_SUITESPARSE) \
		-DALICEVISION_USE_ALEMBIC=ON \
		-DALICEVISION_USE_APRILTAG=ON \
		-DALICEVISION_USE_CCTAG=OFF \
		-DALICEVISION_USE_CUDA=ON \
		-DALICEVISION_USE_MESHSDFILTER=ON \
		-DALICEVISION_USE_NVTX_PROFILING=OFF \
		-DALICEVISION_USE_OCVSIFT=$(USE_OCVSIFT) \
		-DALICEVISION_USE_ONNX=OFF \
		-DALICEVISION_USE_ONNX_GPU=OFF \
		-DALICEVISION_USE_OPENCV=ON \
		-DALICEVISION_USE_OPENCV_CONTRIB=ON \
		-DALICEVISION_USE_OPENGV=ON \
		-DALICEVISION_USE_OPENMP=ON \
		-DALICEVISION_USE_POPSIFT=OFF \
		-DALICEVISION_USE_RPATH=OFF \
		-DALICEVISION_USE_UNCERTAINTYTE=OFF \
		-DBOOST_NO_CXX11=OFF \
		-DLEMON_INCLUDE_DIR_HINTS=/usr/include/lemon/ \
		-DFLANN_INCLUDE_DIR_HINTS=/usr/include/flann/ \
		-DGEOGRAM_LIBRARY=/usr/lib/$(DEB_HOST_GNU_TYPE)/libgeogram.so \
		-DGEOGRAM_INCLUDE_DIR=/usr/include/geogram1

# To make the tests pass I need to set ALICEVISION_ROOT to some directory inside
# the build tree. I get this as relative to this debian/rules file
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	ALICEVISION_ROOT=$(dir $(realpath $(lastword $(MAKEFILE_LIST))))/../src/aliceVision/image dh_auto_test
endif

# Extra notes in /usr/share/aliceVision shouldn't live there, but they're not
# useful anyway, so I remove them
execute_after_dh_auto_install:
	rm debian/tmp/usr/share/aliceVision/*.md

=== debian/watch ===
version=4
opts=\
repacksuffix=+repack,\
dversionmangle=s/\+repack//g,\
repack,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/AliceVision-$1\.tar\.gz/ \
 https://github.com/alicevision/AliceVision/tags .*/v?(\d\S+)\.tar\.gz

## alicevision 3.3.1%2Brepack

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
